﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text;
using System.Collections;
using System.Web.UI;
using System.Net;

using CMS.GlobalHelper;
using CMS.Ecommerce;
using CMS.SiteProvider;
using CMS.CMSHelper;
using CMS.SettingsProvider;
using CMS.EventLog;
using CMS.EcommerceProvider;

namespace CustomProvider
{
    public class PaymentProvider : CMSPaymentGatewayProvider
    {       

        public override PaymentResultInfo CreatePaymentResultInfo()
        {
            // custom code ...

            // return some PaymentResultInfo
            return new PaymentResultInfo();

        }

        /// <summary>
        /// Process payment.
        /// </summary>
        public override void ProcessPayment()
        {            
          // custom code ...                          
        }


        /// <summary>
        /// Returns paymet gateway form with custom controls.
        /// </summary>
        public override CMSPaymentGatewayForm GetPaymentDataForm()
        {
            try
            {
                // this is just an example ....
                Control ctrl = this.ShoppingCartControl.LoadControl("~/CMSModules/Ecommerce/Controls/PaymentGateways/AuthorizeNetForm.ascx");
                ctrl.ID = "shoppingCartControl";
                return (CMSPaymentGatewayForm)ctrl;
            }
            catch (Exception ex)
            {
                try
                {
                    int siteId = 0;
                    int userId = 0;
                    string userName = "";


                    // Get current user information
                    UserInfo ui = CMSContext.CurrentUser;
                    if (ui != null)
                    {
                        userId = ui.UserID;
                        userName = ui.UserName;
                    }

                    // Get current site information
                    SiteInfo si = CMSContext.CurrentSite;
                    if (si != null)
                    {
                        siteId = si.SiteID;
                    }

                    // Log the event
                    EventLogProvider evenLog = new EventLogProvider();
                    evenLog.LogEvent("E", DateTime.Now, "CustomProvider.PaymentProvider", "EXCEPTION", userId, userName, 0, "", "", EventLogProvider.GetExceptionLogMessage(ex), siteId, UrlHelper.CurrentURL);
                }
                catch
                {
                    // Unable to log the event
                }
            }
            return null;
        }
    }
}
